#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  gtk_object_set_data_full (GTK_OBJECT (component), name, \
    gtk_widget_ref (widget), (GtkDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  gtk_object_set_data (GTK_OBJECT (component), name, widget)

GtkWidget*
create_winMain (void)
{
  GtkWidget *winMain;
  GtkWidget *vbox1;
  GtkWidget *naslov;
  GtkWidget *separator;
  GtkWidget *hbox2;
  GtkWidget *vbox2;
  GtkWidget *tekst;
  GtkWidget *unos;
  GtkWidget *button3;
  GtkWidget *hbox3;
  GtkWidget *notebook1;
  GtkWidget *prostor;
  GtkWidget *lista;
  GtkWidget *recnik;
  GtkWidget *hbox4;
  GtkWidget *vbox4;
  GtkWidget *opis;
  GtkWidget *hbox5;
  GtkWidget *progressbar1;
  GtkWidget *status;
  GtkWidget *vbox3;
  GtkWidget *azuriraj;
  GtkWidget *preuzmi;
  GtkWidget *hbox6;
  GtkWidget *image1;
  GtkWidget *label10;
  GtkWidget *azuriranje;
  GtkWidget *hbox1;
  GtkWidget *label2;
  GtkWidget *zatvori;
  GtkWidget *statusbar;

GtkTreeStore *store;
GtkTreeSelection *select;
GtkCellRenderer *renderer;
GtkTreeViewColumn *column;

  winMain = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (winMain, "winMain");
  gtk_container_set_border_width (GTK_CONTAINER (winMain), 4);
  gtk_window_set_title (GTK_WINDOW (winMain), _("Научимо гноме српски!"));
  gtk_window_set_position (GTK_WINDOW (winMain), GTK_WIN_POS_CENTER);

  vbox1 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (winMain), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  naslov = gtk_label_new (_("<span weight=\"bold\" size=\"x-large\" color=\"#666666\">Речник за превод гноме окружења на српски језик</span>"));
  gtk_widget_set_name (naslov, "naslov");
  gtk_widget_show (naslov);
  gtk_box_pack_start (GTK_BOX (vbox1), naslov, FALSE, TRUE, 4);
  gtk_label_set_use_markup ((GtkLabel *) naslov, TRUE);
  gtk_label_set_justify (GTK_LABEL (naslov), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (naslov), TRUE);
  gtk_misc_set_alignment (GTK_MISC (naslov), 0.1, 0);
  gtk_misc_set_padding (GTK_MISC (naslov), 1, 0);

  separator = gtk_hseparator_new ();
  gtk_widget_set_name (separator, "separator");
  gtk_widget_show (separator);
  gtk_box_pack_start (GTK_BOX (vbox1), separator, FALSE, FALSE, 0);
  gtk_widget_set_usize (separator, -2, 2);

  hbox2 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 1);

  vbox2 = gtk_vbox_new (TRUE, 0);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox2, TRUE, TRUE, 0);

  tekst = gtk_label_new (_("Пронађи енглески термин у речнику:"));
  gtk_widget_set_name (tekst, "tekst");
  gtk_widget_show (tekst);
  gtk_box_pack_start (GTK_BOX (vbox2), tekst, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (tekst), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (tekst), 0.05, 0.5);

  unos = gtk_entry_new ();
  gtk_widget_set_name (unos, "unos");
  gtk_widget_show (unos);
  gtk_box_pack_start (GTK_BOX (vbox2), unos, TRUE, FALSE, 0);

  button3 = gtk_button_new_from_stock ("gtk-find");
  gtk_widget_set_name (button3, "button3");
  gtk_widget_show (button3);
  gtk_box_pack_start (GTK_BOX (hbox2), button3, TRUE, TRUE, 0);
  gtk_widget_set_usize (button3, 1, -2);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  notebook1 = gtk_notebook_new ();
  gtk_widget_set_name (notebook1, "notebook1");
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (hbox3), notebook1, TRUE, TRUE, 0);

  prostor = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (prostor, "prostor");
  gtk_widget_show (prostor);
  gtk_container_add (GTK_CONTAINER (notebook1), prostor);


  store= gtk_tree_store_new (BR_KOLONA,
                                          G_TYPE_STRING,
                                          G_TYPE_STRING);

/*
GtkTreeIter   iter;


gtk_tree_store_append (store, &iter, NULL);
gtk_tree_store_set (store, &iter,
                    ENG, "Copy",
                    SRP, "Dupliraj",
                    -1);
*/

lista = gtk_tree_view_new_with_model (GTK_TREE_MODEL (store));
g_object_unref (G_OBJECT (store));

select = gtk_tree_view_get_selection (GTK_TREE_VIEW (lista));
gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);
g_signal_connect (G_OBJECT (select), "changed",
                  G_CALLBACK (on_select_lista),
                  NULL);
		  


renderer = gtk_cell_renderer_text_new ();
column = gtk_tree_view_column_new_with_attributes ("Engleski",
                                                   renderer,
                                                   "text", ENG,
                                                   NULL);
gtk_tree_view_append_column (GTK_TREE_VIEW (lista), column);



renderer = gtk_cell_renderer_text_new ();
column = gtk_tree_view_column_new_with_attributes ("Srpski",
                                                   renderer,
                                                   "text", SRP,
                                                   NULL);
gtk_tree_view_append_column (GTK_TREE_VIEW (lista), column);


    gtk_container_add (GTK_CONTAINER (prostor), lista);
    gtk_widget_show (lista);
    gtk_widget_set_name (lista, "lista");




  recnik = gtk_label_new (_("речник"));
  gtk_widget_set_name (recnik, "recnik");
  gtk_widget_show (recnik);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), recnik);
  gtk_label_set_justify (GTK_LABEL (recnik), GTK_JUSTIFY_LEFT);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (notebook1), hbox4);

  vbox4 = gtk_vbox_new (FALSE, 4);
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (hbox4), vbox4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 4);

  opis = gtk_label_new (_("Искористите ову опцију како бисте ажурирали локалну копију базе речника. Базу речника можете преузети и директно на интернет локацији превод.орг.\n\nСве допуне речника које желите да изведете можете урадити директно на интернет локацији превод.орг одабиром секције \"речник\" у главном менију.\n"));
  gtk_widget_set_name (opis, "opis");
  gtk_widget_show (opis);
  gtk_box_pack_start (GTK_BOX (vbox4), opis, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (opis), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (opis), TRUE);

  hbox5 = gtk_hbox_new (FALSE, 7);
  gtk_widget_set_name (hbox5, "hbox5");
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox5), 5);

  progressbar1 = gtk_progress_bar_new ();
  gtk_widget_set_name (progressbar1, "progressbar1");
  gtk_widget_show (progressbar1);
  gtk_box_pack_start (GTK_BOX (hbox5), progressbar1, TRUE, TRUE, 0);

  status = gtk_label_new (_("<span size=\"small\" color=\"#666666\">Тренутно не радим ништа.</span>"));
  gtk_widget_set_name (status, "status");
  gtk_widget_show (status);
  gtk_box_pack_start (GTK_BOX (vbox4), status, FALSE, FALSE, 0);
  gtk_label_set_use_markup ((GtkLabel *) status, TRUE);
  gtk_label_set_justify (GTK_LABEL (status), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (status), 0.95, 0.5);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox4), vbox3, TRUE, TRUE, 4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 15);

  azuriraj = gtk_button_new ();
  gtk_widget_set_name (azuriraj, "azuriraj");
  gtk_widget_show (azuriraj);
  gtk_box_pack_start (GTK_BOX (vbox3), azuriraj, FALSE, FALSE, 0);

  preuzmi = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_set_name (preuzmi, "preuzmi");
  gtk_widget_show (preuzmi);
  gtk_container_add (GTK_CONTAINER (azuriraj), preuzmi);

  hbox6 = gtk_hbox_new (FALSE, 2);
  gtk_widget_set_name (hbox6, "hbox6");
  gtk_widget_show (hbox6);
  gtk_container_add (GTK_CONTAINER (preuzmi), hbox6);

  image1 = gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_LARGE_TOOLBAR);
  gtk_widget_set_name (image1, "image1");
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox6), image1, FALSE, FALSE, 0);

  label10 = gtk_label_new_with_mnemonic (_("преузми нову\nбазу речника\nса интернета"));
  gtk_widget_set_name (label10, "label10");
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (hbox6), label10, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label10), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label10), TRUE);

  azuriranje = gtk_label_new (_("ажурирање"));
  gtk_widget_set_name (azuriranje, "azuriranje");
  gtk_widget_show (azuriranje);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), azuriranje);
  gtk_label_set_justify (GTK_LABEL (azuriranje), GTK_JUSTIFY_LEFT);

  hbox1 = gtk_hbox_new (FALSE, 13);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  label2 = gtk_label_new (_("<span size=\"small\">Програм развио Горан Ракић као подршка превођењу гноме окружења на српски језик. Програм је објављен под GNU GPL лиценцом</span>"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox1), label2, TRUE, TRUE, 0);
  gtk_label_set_use_markup ((GtkLabel *) label2, TRUE);
  gtk_label_set_line_wrap (GTK_LABEL (label2), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label2), 0.1, 0.5);

  zatvori = gtk_button_new_from_stock ("gtk-quit");
  gtk_widget_set_name (zatvori, "zatvori");
  gtk_widget_show (zatvori);
  gtk_box_pack_start (GTK_BOX (hbox1), zatvori, TRUE, TRUE, 0);

  statusbar = gtk_statusbar_new ();
  gtk_widget_set_name (statusbar, "statusbar");
  gtk_widget_show (statusbar);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (on_click_pretrazi),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (zatvori), "clicked",
                      GTK_SIGNAL_FUNC (on_zatvori_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (azuriraj), "clicked",
                      GTK_SIGNAL_FUNC (on_click_azuriraj),
                      NULL);
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (winMain, winMain, "winMain");
  GLADE_HOOKUP_OBJECT (winMain, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (winMain, naslov, "naslov");
  GLADE_HOOKUP_OBJECT (winMain, separator, "separator");
  GLADE_HOOKUP_OBJECT (winMain, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (winMain, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (winMain, tekst, "tekst");
  GLADE_HOOKUP_OBJECT (winMain, unos, "unos");
  GLADE_HOOKUP_OBJECT (winMain, button3, "button3");
  GLADE_HOOKUP_OBJECT (winMain, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (winMain, notebook1, "notebook1");
  GLADE_HOOKUP_OBJECT (winMain, prostor, "prostor");
  GLADE_HOOKUP_OBJECT (winMain, lista, "lista");
  GLADE_HOOKUP_OBJECT (winMain, recnik, "recnik");
  GLADE_HOOKUP_OBJECT (winMain, hbox4, "hbox4");
  GLADE_HOOKUP_OBJECT (winMain, vbox4, "vbox4");
  GLADE_HOOKUP_OBJECT (winMain, opis, "opis");
  GLADE_HOOKUP_OBJECT (winMain, hbox5, "hbox5");
  GLADE_HOOKUP_OBJECT (winMain, progressbar1, "progressbar1");
  GLADE_HOOKUP_OBJECT (winMain, status, "status");
  GLADE_HOOKUP_OBJECT (winMain, vbox3, "vbox3");
  GLADE_HOOKUP_OBJECT (winMain, azuriraj, "azuriraj");
  GLADE_HOOKUP_OBJECT (winMain, preuzmi, "preuzmi");
  GLADE_HOOKUP_OBJECT (winMain, hbox6, "hbox6");
  GLADE_HOOKUP_OBJECT (winMain, image1, "image1");
  GLADE_HOOKUP_OBJECT (winMain, label10, "label10");
  GLADE_HOOKUP_OBJECT (winMain, azuriranje, "azuriranje");
  GLADE_HOOKUP_OBJECT (winMain, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (winMain, label2, "label2");
  GLADE_HOOKUP_OBJECT (winMain, zatvori, "zatvori");
  GLADE_HOOKUP_OBJECT (winMain, statusbar, "statusbar");

  return winMain;
}

